package com.syc.slm.slmbi.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.syc.slm.slmbi.dto.*;
import com.syc.slm.slmbi.entity.CurrentUser;
import com.syc.slm.slmbi.vo.*;
import lombok.NonNull;

import java.util.List;
import java.util.Map;

/**
 * slm-bi
 * 变量
 *
 * @author : lin
 * @date : 2021-03-25 16:17
 **/
public interface VariableService {
    /**
     * 获取变量列表
     * @param variableDTO
     * @return
     */
    IPage<VariableVo> getVariableList(VariableDTO variableDTO,String appId,String token,String uri);

    /**
     * 获取变量来源
     * @return
     */
    List<VariableSourceVo> getVariableSourceList();

    /**
     * 获取变量所属设备
     * @param token
     * @param appId
     * @param uri
     * @param queryPageDTO
     * @return
     */
    IPage<VariableDeviceVo> getVariableDeviceList(String token,String appId,String uri, QueryPageDTO queryPageDTO);

    /**
     * 获取实时数据
     * @param uri
     * @param variableDTO
     * @param user
     * @return
     */
    Map<String,List<Map<String,Object>>> getVariableRealTimeDataList(@NonNull String uri,VariableRealTimeDTO variableDTO,CurrentUser user);

    /**
     * 获取历史数据
     * @param uri
     * @param variableDTO
     * @param currentUser
     * @return
     */
    List<Map<String,List<Map<String,Object>>>> getVariableHistoryDataList(@NonNull String uri,
        VariableHistoryDataDTO variableDTO,CurrentUser currentUser);

    /**
     * 下发
     * @param sendDTO
     * @param currentUser
     * @param uri
     */
    void send(VariableSendDTO sendDTO, CurrentUser currentUser,String uri);

    /**
     * 状态点实时数据
     * @param uri
     * @param deviceId
     * @param variableCode
     * @return
     */
    Map<String,Object> status(String uri,String deviceId,String variableCode,CurrentUser user);

    /**
     * 状态点历史数据
     * @param uri
     * @param deviceId
     * @param variableCode
     * @param startTime
     * @param endTime
     * @param currentUser
     * @return
     */
    Map<String,Object> historyStatus(String uri, String deviceId, String variableCode, String startTime, String endTime, CurrentUser currentUser);

    /**
     * 获取历史双曲线
     * @param variableDTO
     * @param currentUser
     * @return
     */
    List<Map<String, Object>> getVariableHistoryCurve(VariableHistoryCurveDataDTO variableDTO, CurrentUser currentUser,String uri);
}
